--Addons--
AddonsColor = {
	{
		FName = "Normal",
		r = 255, g = 255, b = 255,
	},
	{
		FName = "Blue",
		r = 0, g = 0, b = 128,
	},
	{
		FName = "Red",
		r = 128, g = 0, b = 0,
	},
	{
		FName = "Green",
		r = 0, g = 128, b = 0,
	},
	{
		FName = "Yellow",
		r = 255, g = 255, b = 0,
	},
}
Addons = {
	{
		No = 1,
		FName 	= "Wings",
		FPrice  = 500000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 200,				--top = 200 / 100
		FSpeed  = 5,
		health  = 10,
		wpn		= 2,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/bal2.bmp",
		FImageVIP = "",
		FVIPOnTop	= 200,
	},
	{
		No = 2,
		FName 	= "Car",
		FPrice  = 700000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 200,
		FSpeed  = 10,
		health  = 20,
		wpn		= 0,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/car_04.png",
		FImageVIP = "gfx/Blocker Game/car_vip.png",
		FVIPOnTop	= 100,
	},
	{
		No = 3,
		FName 	= "Horse",
		FPrice  = 500000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 100,
		FSpeed  = 10,
		health  = 10,
		wpn		= 51,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/horse.PNG",
		FImageVIP = "",
		FVIPOnTop	= 100,
	},
	{
		No = 4,
		FName 	= "Hero",
		FPrice  = 800000,
		r = 255, g = 255, b = 255,
		FIMGBlend=1, FIMGAlpha=0.8,
		FOnTop	= 100,
		FSpeed  = 15,
		health  = 30,
		wpn		= 5,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/sh_oval_3.png",
		FImageVIP = "",
		FVIPOnTop	= 100,
	},
	{
		No = 5,
		FName 	= "Tank",
		FPrice  = 1200000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 200,
		FSpeed  = -5,
		health  = 50,
		wpn		= 47,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/tank.bmp",
		FImageVIP = "",
		FVIPOnTop	= 200,
	},
	{
		No = 6,
		FName 	= "Dragon",
		FPrice  = 900000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 200,
		FSpeed  = 20,
		health  = 0,
		wpn		= 46,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/dragon.png",
		FImageVIP = "",
		FVIPOnTop	= 200,
	},
	{
		No = 7,
		FName 	= "Evil",
		FPrice  = 1000000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 200,
		FSpeed  = 15,
		health  = 60,
		wpn		= 23,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/Evil.png",
		FImageVIP = "",
		FVIPOnTop	= 200,
	},
	{
		No = 8,
		FName 	= "Truck",
		FPrice  = 800000,
		r = 0, g = 0, b = 0,
		FIMGBlend=0, FIMGAlpha=0,
		FOnTop	= 200,
		FSpeed  = 10,
		health  = 20,
		wpn		= 0,
		FLic = Array(32, 0),
		FHave= Array(32, 0),
		FImage	= "gfx/Blocker Game/3.png",

	},
}

function InternalFreeAddons(id)
	for k, v in ipairs(Addons) do
		v.FHave[id]=0
		v.FLic[id]=0
	end
end

function SetAddons(id,isTrue)
	for k, v in ipairs(Addons) do
		v.FLic[id]=isTrue
	end
end

function CreateAddonsMenu(id)
	local TmpStr=""
	for k, v in ipairs(Addons) do
		TmpStr = TmpStr..v.FName.." |("..v.FLic[id].."/"..v.FHave[id].."),"
	end
	menu(id,"Add-ons Menu,"..TmpStr)
end

function CreateAddonsSell(id)
	local TmpStr=""
	for k, v in ipairs(Addons) do
		TmpStr = TmpStr..v.FName.." |Pirc("..v.FLic[id].."/"..v.FPrice.."),"
	end
	menu(id,"Buy Add-ons,"..TmpStr)
end

function CreateAddonsColor(id)
	local TmpStr=""
	for k, v in ipairs(AddonsColor) do
		TmpStr = TmpStr..v.FName..","
	end
	menu(id,"Add-ons Color,"..TmpStr)
end


function RemoveTemporaryAddons(id)
	for k, v in ipairs(Addons) do
		if v.FHave[id]==1 then
			local playerHealth = player(id,"health")
			if (v.wpn > 0) and (checkwep(id,v.wpn)==1) then
				parse("strip "..id.." "..v.wpn)
			end
			if (playerHealth > 100) then
				parse("setmaxhealth "..id.." 100")
			end
		end
	end
end

function selAddonsColor(id,sel)
	local playerHealth = player(id,"health")
	if 	playerHealth>0 then
		for k, v in ipairs(Addons) do
			if v.FHave[id]==1 then
				InternalFreeImage(id)
				v.FHave[id]=1
				if (rp_vipaddons[id]==1) and (v.FImageVIP~="") then
					PicImage[id]=image(v.FImageVIP,1,1,v.FVIPOnTop+id)		
				else
					PicImage[id]=image(v.FImage,1,1,v.FOnTop+id)					
				end
				imagecolor(PicImage[id],AddonsColor[sel].r,AddonsColor[sel].g,AddonsColor[sel].b)
				if v.FIMGBlend>0 then
					imageblend(PicImage[id],1)
				end
				if v.FIMGAlpha>0 then
					imagealpha(PicImage[id], 0.8)
				end
			end
		end
	end
end

function giveaddonsto(id,addonsno)

end

function SelAddonsMenu(id,sel)
	local playerHealth = player(id,"health")
	if 	playerHealth>0 then
		if  Addons[sel].FLic[id] == 1 then
			if Addons[sel].FHave[id] == 1 then
				RemoveTemporaryAddons(id)
				InternalFreeImage(id)
				parse("speedmod "..id.." 0")
			else
				RemoveTemporaryAddons(id)
				InternalFreeImage(id)
				Addons[sel].FHave[id]=1
				if (rp_vipaddons[id]==1) and (Addons[sel].FImageVIP~="") then
					PicImage[id]=image(Addons[sel].FImageVIP,1,1,Addons[sel].FVIPOnTop+id)		
				else
					PicImage[id]=image(Addons[sel].FImage,1,1,Addons[sel].FOnTop+id)					
				end
				if (Addons[sel].r > 0) or (Addons[sel].g > 0) or (Addons[sel].b > 0) then
					imagecolor(PicImage[id],Addons[sel].r,Addons[sel].g,Addons[sel].b)
				end	
				if Addons[sel].FIMGBlend>0 then
					imageblend(PicImage[id],1)
				end
				if Addons[sel].FIMGAlpha>0 then
					imagealpha(PicImage[id], 0.8)
				end
				
				parse("speedmod "..id.." "..Addons[sel].FSpeed)
				if Addons[sel].wpn > 0 then
					parse("equip "..id.." "..Addons[sel].wpn);
					parse("setweapon "..id.." "..Addons[sel].wpn)					
				end
				if (playerHealth <= 100) and (Addons[sel].health > 0) then
					parse("setmaxhealth "..id.." "..Addons[sel].health+playerHealth)
				end
			end
		else
			rp_msg2(id,"255000000","You must to be "..Addons[sel].FName.." licenced!")
		end
	end
end