------
-- Emoticons for CS2D by Häppy C@mper
--


HC_EMOTICONS = {
    ["^[:=8][-^o]?[)%]3>]$"]            = "smiling", -- :)
    ["^%^[_]?%^$"]                      = "smiling", -- ^_^
    ["^[:=8][-^o]?[D]$"]                = "smiling_big", -- :D
    ["^[:=8][-^o]?[(%[]$"]              = "frowning", -- :(
    ["^[;][-^o]?[)%]D]$"]               = "winking", -- ;)
    ["^[xX][-^o]?[D]+$"]                = "laughing", -- xD
    ["^[lL1][oO0]+[lL1]+[sSzZ]*%??$"] = "laughing", -- lol
    ["^[hH][aAeEoO][hH][aAeEoO]$"]  = "laughing", -- hehe
    ["^[rR][oO��0]+[fF][lL1]+$"]    = "laughing", -- rofl
    ["^[:=8xX][-^o]?[pPbq]$"]           = "cheeky", -- :P
    ["^[:=8xX]['][-^o]?%($"]            = "crying", -- :'(
    ["^[;][-]?%($"]                     = "crying", -- ;(
    ["^D[-^o]?[:=8xX]$"]                = "crying", -- Dx
    ["^T[_.-]?T$"]                      = "crying", -- T_T
    ["^[:=8][-^o]?[oO0]$"]              = "surprised", -- :O
    ["^[oO0][_.-]?[oO0]$"]              = "surprised", -- O_o
    ["^[oO0][mM][gG]$"]                 = "surprised", -- omg
    ["^[:=8][-^o]?[/\\]$"]              = "skeptical", -- :/
    ["^[:=8][-^o]?[sS]$"]               = "uneasy", -- :S
    ["^>[:=8;][-^o]?[)%]D]$"]           = "evil", -- >:D
    ["^>[_.-]<$"]                       = "angry", -- >_<
    ["^>[:=8;][-^o]?[(%[]$"]            = "angry", -- >:(
    ["^<3$"]                            = "heart" -- <3
}


HC_EMOTICON_LINGER_TIME = 3
HC_EMOTICON_FADE_IN_STEP = 0.30
HC_EMOTICON_FADE_OUT_STEP = 0.20
HC_EMOTICON_OPACITY = 0.60
HC_EMOTICON_PATH = "gfx/hc/emoticons/"


function hc_emoticons_init()
    addhook("say", "hc_say_hook")
    addhook("ms100", "hc_ms100_hook")
    addhook("leave", "hc_leave_hook")

    hc_smiling_players = {}
    hc_emoticons = {}

    for i = 1, 32 do
        hc_emoticons[i] = {}
    end
end

hc_emoticons_init()

function hc_leave_hook(p, reason)
    if hc_emoticons[p].smiley_time ~= nil then
        freeimage(hc_emoticons[p].emoticon)
        freeimage(hc_emoticons[p].speechbubble)
        for i, id in ipairs(hc.chat.smiling_players) do
            if id == p then
                table.remove(hc.chat.smiling_players, i)
                break
            end
        end
    end
    hc_emoticons[p] = {}
end

function hc_ms100_hook()
    local still_smiling_players = {}

    for i, p in ipairs(hc_smiling_players) do
        local time = os.difftime(os.time(), hc_emoticons[p].smiley_time)

        if time < HC_EMOTICON_LINGER_TIME and hc_emoticons[p].alpha < HC_EMOTICON_OPACITY then
            hc_emoticons[p].alpha = hc_emoticons[p].alpha + HC_EMOTICON_FADE_IN_STEP
            imagealpha(hc_emoticons[p].speechbubble, hc_emoticons[p].alpha)
            imagealpha(hc_emoticons[p].emoticon, hc_emoticons[p].alpha)
            table.insert(still_smiling_players, p)
        elseif time > HC_EMOTICON_LINGER_TIME then
            hc_emoticons[p].alpha = hc_emoticons[p].alpha - HC_EMOTICON_FADE_OUT_STEP
            if hc_emoticons[p].alpha <= 0 then
                freeimage(hc_emoticons[p].emoticon)
                freeimage(hc_emoticons[p].speechbubble)
                hc_emoticons[p].smiley_time = nil
                hc_emoticons[p].emoticon = nil
                hc_emoticons[p].speechbubble = nil
            else
                imagealpha(hc_emoticons[p].speechbubble, hc_emoticons[p].alpha)
                imagealpha(hc_emoticons[p].emoticon, hc_emoticons[p].alpha)
                table.insert(still_smiling_players, p)
            end
        else
            table.insert(still_smiling_players, p)
        end
    end
    hc_smiling_players = still_smiling_players
end

function hc_say_hook(p, text)
    if player(p, "team") ~= 3 and player(p, "health") > 0 then
        hc_check_for_smileys(p, text)
    end
end

function hc_check_for_smileys(p, message)
    for word in string.gmatch(message, "[^%s]+") do
        for smiley, emoticon in pairs(HC_EMOTICONS) do
            if word:match(smiley) then
                hc_show_emoticon(p, emoticon)
                return
            end
        end
    end
end

function hc_show_emoticon(p, emoticon)
    if hc_emoticons[p].emoticon ~= nil then
        freeimage(hc_emoticons[p].emoticon)
    else
        table.insert(hc_smiling_players, p)
        hc_emoticons[p].speechbubble = image(HC_EMOTICON_PATH .. "speechbubble.png", 0, 0, 200 + p)
        hc_emoticons[p].alpha = HC_EMOTICON_FADE_IN_STEP
    end
    hc_emoticons[p].smiley_time = os.time()
    hc_emoticons[p].emoticon = image(HC_EMOTICON_PATH .. emoticon .. ".png", 0, 0, 200 + p)
    imagealpha(hc_emoticons[p].speechbubble, hc_emoticons[p].alpha)
    imagealpha(hc_emoticons[p].emoticon, hc_emoticons[p].alpha)
end
